/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * ExportHandler.java
 *
 * Created on 27. joulukuuta 2004, 14:59
 */

package kumbang.configurator.client.core;

import kumbang.configurator.client.core.exception.ExportException;

import kumbang.core.configuration.description.KumbangConfigurationDescription;
import kumbang.core.configuration.description.XMLConfigurationDescription;

import kumbang.core.configuration.instance.Instance;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

import java.util.ArrayList;
import java.util.List;

/**
 * 
 * @author vmyllarn
 */
public class ExportHandler {

    private XMLConfigurationDescription xmlDescription;
    
    private KumbangConfigurationDescription strDescription;
    
    /** Creates a new instance of ExportHandler */
    public ExportHandler() {
        this.xmlDescription = new XMLConfigurationDescription();
        this.strDescription = new KumbangConfigurationDescription();
    }

    public void reset() { }

    public void export(File exportTarget, String name, int format, List<Instance> roots) throws ExportException {
        if (format == ClientProperties.EXPORT_FORMAT_TEXT) {
            exportToKumbang(exportTarget, name, roots);
        } else if (format == ClientProperties.EXPORT_FORMAT_XML) {
            exportToXML(exportTarget, name, roots);
        }
    }

    private void exportToKumbang(File exportTarget, String name, List<Instance> roots) throws ExportException {
        try {
            strDescription.describe(exportTarget, roots, name);
        } catch (IOException ioe) {
            throw new ExportException(exportTarget, ioe.toString());
        }
    }

    private void exportToXML(File exportTarget, String name, List<Instance> roots) throws ExportException {
        try {
        	xmlDescription.describe(exportTarget, roots, name);
        } catch (IOException ioe) {
            throw new ExportException(exportTarget, ioe.toString());
        }
    }
}
