/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * OpenException.java
 *
 * Created on 30. joulukuuta 2004, 13:11
 */

package kumbang.configurator.client.core.exception;

import java.io.File;

/**
 *
 * @author  vmyllarn
 */
public class OpenException extends ClientException {
    
    /**
     * Creates a new instance of <code>OpenException</code> without detail message.
     */
    public OpenException(File openFile, String msg) {
        super("Cannot open configuration from file "+openFile+".\n"+msg);
    }
    
    
    /**
     * Constructs an instance of <code>OpenException</code> with the specified detail message.
     * @param msg the detail message.
     */
    public OpenException(String modelName, String msg) {
        super("Cannot open model "+modelName+".\n"+msg);
    }
    
    protected OpenException(String msg) {
    	super(msg);
    }    
}
