/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * SaveException.java
 *
 * Created on 30. joulukuuta 2004, 12:39
 */

package kumbang.configurator.client.core.exception;

import java.io.File;

/**
 *
 * @author  vmyllarn
 */
public class SaveException extends ClientException {
    
    /**
     * Creates a new instance of <code>SaveException</code> with default message.
     * @param exportFile file that was used for exporting
     */
    public SaveException(File saveFile) {
        super("Cannot save configuration to file "+saveFile+".");
    }
    
    
    /**
     * Constructs an instance of <code>SaveException</code> with the specified detail message.
     * @param exportFile file that was used for exporting
     * @param msg the detail message.
     */
    public SaveException(File saveFile, String msg) {
        super("Cannot save configuration to file "+saveFile+".\n"+msg);
    }
    
    protected SaveException(String msg) {
    	super(msg);
    }    
}
