/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * Created on 26.7.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package kumbang.configurator.client.gui.core;

import java.awt.Component;
import java.awt.Container;

import javax.swing.JTabbedPane;
import javax.swing.JTree;
import javax.swing.LayoutFocusTraversalPolicy;

/**
 * @author vmyllarn
 */
public class ClientFocusTraversalPolicy extends LayoutFocusTraversalPolicy {

    private MainGUI mainGUI;
    
    private JTabbedPane treeTabs;
    
    private JTree fTree;
    
    private JTree cTree;
    
    private JTabbedPane diagramTabs;
    
    private FeatureInfoPanel fPanel;
    
    private ComponentDiagramPanel cPanel;
    
    private boolean traversingFeaturePanel = false;
    
    private boolean traversingComponentPanel = false;
    
    //private List mainGUIComponents;
    
    /**
     * 
     */
    public ClientFocusTraversalPolicy(MainGUI mainGUI, 
                                      JTabbedPane treeTabs, 
                                      JTree fTree,
                                      JTree cTree,
                                      JTabbedPane diagramTabs, 
                                      FeatureInfoPanel fPanel, 
                                      ComponentDiagramPanel cPanel) {
        this.mainGUI = mainGUI;
        this.treeTabs = treeTabs;
        this.fTree = fTree;
        this.cTree = cTree;
        this.diagramTabs = diagramTabs;
        this.fPanel = fPanel;
        this.cPanel = cPanel;
        //this.mainGUIComponents = new ArrayList();
    }
    
    public Component getComponentAfter(Container focusCycleRoot, Component aComponent) {
        if (mainGUI.equals(focusCycleRoot)) {
            if (traversingFeaturePanel) {
                aComponent = fPanel.getNextFocusableComponent(aComponent);
                if (aComponent == null) {
                    traversingFeaturePanel = false;
                    return treeTabs;
                } else {
                    return aComponent;
                }
            }
            if (traversingComponentPanel) {
                aComponent = cPanel.getNextFocusableComponent(aComponent);
                if (aComponent == null) {
                    traversingComponentPanel = false;
                    return treeTabs;
                } else {
                    return aComponent;
                }
            }
            if (aComponent.equals(treeTabs)) {
                if (treeTabs.getSelectedIndex() == MainGUI.TAB_INDEX_FEATURE) {
                    return fTree;
                } else {
                    return cTree;
                }
            } else if (aComponent.equals(diagramTabs)) {
                if (diagramTabs.getSelectedIndex() == MainGUI.TAB_INDEX_FEATURE) {
                    aComponent = fPanel.getFirstFocusableComponent();
                    if (aComponent == null) {
                        return treeTabs;
                    } else {
                        traversingFeaturePanel = true;
                        return aComponent;
                    }
                } else {
                    aComponent = cPanel.getFirstFocusableComponent();
                    if (aComponent == null) {
                        return treeTabs;
                    } else {
                        traversingComponentPanel = true;
                        return aComponent;
                    }
                }
            } else if (aComponent.equals(fTree) || aComponent.equals(cTree)) {
                return diagramTabs;
            } else {
                return treeTabs;
            }
        }
        return null;
    }
    
    public Component getComponentBefore(Container focusCycleRoot, Component aComponent) {
        if (mainGUI.equals(focusCycleRoot)) {
            if (traversingFeaturePanel) {
                aComponent = fPanel.getPreviousFocusableComponent(aComponent);
                if (aComponent == null) {
                    traversingFeaturePanel = false;
                    return diagramTabs;
                } else {
                    return aComponent;
                }
            }
            if (traversingComponentPanel) {
                aComponent = cPanel.getPreviousFocusableComponent(aComponent);
                if (aComponent == null) {
                    traversingComponentPanel = false;
                    return diagramTabs;
                } else {
                    return aComponent;
                }
            }
            if (aComponent.equals(treeTabs)) {
                if (diagramTabs.getSelectedIndex() == MainGUI.TAB_INDEX_FEATURE) {
                    aComponent = fPanel.getLastFocusableComponent();
                    if (aComponent == null) {
                        return diagramTabs;
                    } else {
                        traversingFeaturePanel = true;
                        return aComponent;
                    }
                } else {
                    aComponent = cPanel.getLastFocusableComponent();
                    if (aComponent == null) {
                        return diagramTabs;
                    } else {
                        traversingComponentPanel = true;
                        return aComponent;
                    }
                }
            } else if (aComponent.equals(diagramTabs)) {
                if (treeTabs.getSelectedIndex() == MainGUI.TAB_INDEX_FEATURE) {
                    return fTree;
                } else {
                    return cTree;
                }
            } else if (aComponent.equals(fTree) || aComponent.equals(cTree)) {
                return treeTabs;
            } else {
                return diagramTabs;
            }
        }
        return null;
    }
    
    public Component getFirstComponent(Container focusCycleRoot) {
        if (mainGUI.equals(focusCycleRoot)) {
            return treeTabs;
        }
        return null;
    }
    
    public Component getLastComponent(Container focusCycleRoot) {
        if (mainGUI.equals(focusCycleRoot)) {
            if (diagramTabs.getSelectedIndex() == MainGUI.TAB_INDEX_FEATURE) {
                Component aComponent = fPanel.getLastFocusableComponent();
                if (aComponent == null) {
                    return diagramTabs;
                } else {
                    traversingFeaturePanel = true;
                    return aComponent;
                }
            } else {
                return cPanel;
            }
        }
        return null;
    }
}
