/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * BindingElement.java
 *
 * Created on 31. maaliskuuta 2004, 13:13
 */

package kumbang.configurator.client.gui.diagram;

import kumbang.core.configuration.instance.BindingInstance;
import kumbang.core.configuration.instance.Instance;

/**
 *
 * @author  vmyllarn
 */
public class BindingElement extends ConnectorElement implements InstantiatedElement {
    
    private BindingInstance instance;
    
    /** Creates a new instance of BindingElement */
    public BindingElement(ConnectableElement elem1, ConnectableElement elem2, BindingInstance instance) {
        super(elem1, elem2);
        this.instance = instance;
    }
    
    public Instance getInstance() {
        return this.instance;
    }
    
    public BindingInstance getBindingInstance() {
        return this.instance;
    }
}
