/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * InstantiatedElement.java
 *
 * Created on 31. maaliskuuta 2004, 14:12
 */

package kumbang.configurator.client.gui.diagram;

import kumbang.core.configuration.instance.Instance;

/**
 * This interface represents an element which has an instance as a counterpart.
 * For example, aggregation connector does not have a corresponding instance,
 * so it is not an instantiated element.
 *
 * @author  vmyllarn
 */
public interface InstantiatedElement {
    
    public Instance getInstance();
    
}
