/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * EditConfigurationPreferencesDialog.java
 *
 * Created on 26. huhtikuuta 2004, 14:45
 */

package kumbang.configurator.client.gui.dialog;

import kumbang.configurator.client.gui.core.MainGUI;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Box;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JRadioButton;


/**
 *
 * @author  vmyllarn
 */
public class EditConfigurationPreferencesDialog extends TemplateDialog implements ActionListener {
    
    private boolean applyConsequencesAuto;
    
    private JButton ok;
    private JButton cancel;
    
    private JRadioButton applyAuto;
    private JRadioButton applyManual;
    
    /** Creates a new instance of EditConfigurationPreferencesDialog */
    public EditConfigurationPreferencesDialog(MainGUI mainGUI, boolean applyConsequencesAuto) {
        super(mainGUI, "Edit preferences for configuration reasoning");
        this.applyConsequencesAuto = applyConsequencesAuto;
        initComponents();
    }
    
    protected void initComponents() {
        super.addComponent(new JLabel("Edit preferences for configuration reasoning."));
        
        
        applyAuto = new JRadioButton("Apply configuration consequences automatically");
        applyManual = new JRadioButton("Confirm before applying configuration consequences");
        ButtonGroup group = new ButtonGroup();
        group.add(applyAuto);
        group.add(applyManual);
        if (applyConsequencesAuto) {
            applyAuto.setSelected(true);
        }
        else {
            applyManual.setSelected(true);
        }
        
        Box radioBox = Box.createVerticalBox();
        radioBox.add(applyAuto);
        radioBox.add(applyManual);
        super.addComponent(radioBox);
        
        ok = new JButton("OK");
        cancel = new JButton("Cancel");
        ok.addActionListener(this);
        cancel.addActionListener(this);
        super.addButton(ok, true);
        super.addButton(cancel, false);
        
        super.initComponents();
    }
    
    public void actionPerformed(ActionEvent e) {
        Object o = e.getSource();
        if (o == ok) {
            applyConsequencesAuto = applyAuto.isSelected();
            setStatus(STATUS_OK);
            super.dispose();
        }
        else if (o == cancel) {
            super.dispose();
        }
    }
    
    public boolean automaticallyApplyConfigurationConsequences() {
        return applyConsequencesAuto;
    }
}
