/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * ComponentSelectionEvent.java
 *
 * Created on 4. helmikuuta 2005, 11:01
 */

package kumbang.configurator.client.gui.event;

import kumbang.core.configuration.instance.BindingInstance;
import kumbang.core.configuration.instance.ComponentInstance;
import kumbang.core.configuration.instance.Instance;
import kumbang.core.configuration.instance.InterfaceInstance;


import java.util.EventObject;

/**
 *
 * @author  vmyllarn
 */
public class ComponentSelectedEvent extends EventObject {
    
    /** Creates a new instance of ComponentSelectionEvent */
    public ComponentSelectedEvent(ComponentInstance component) {
        super(component);
    }
    
    /** Creates a new instance of ComponentSelectionEvent */
    public ComponentSelectedEvent(InterfaceInstance interf) {
        super(interf);
    }
    
    /** Creates a new instance of ComponentSelectionEvent */
    public ComponentSelectedEvent(BindingInstance binding) {
        super(binding);
    }
    
    public Instance getSelectedInstance() {
        return (Instance) getSource();
    }
}
