/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * AttributeNode.java
 *
 * Created on 9. syyskuuta 2004, 12:43
 */

package kumbang.configurator.client.gui.tree;

import kumbang.util.gui.Icons;

import kumbang.core.configuration.instance.AttributeInstance;
import kumbang.core.configuration.instance.Instance;

/**
 *
 * @author  vmyllarn
 */
public class AttributeNode extends ConfigurationNode implements InstanceNode {
    
    private AttributeInstance instance;
    
    /** Creates a new instance of AttributeNode */
    public AttributeNode(AttributeInstance instance) {
        super(instance, Icons.ATTRIBUTE, Icons.ATTRIBUTE_L);
        this.instance = instance;
    }
    
    public Instance getInstance() {
        return this.instance;
    }
    
    public AttributeInstance getAttributeInstance() {
        return this.instance;
    }
    
    public String toString() {
        return instance.toString();
    }
}
