/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * BindingNode.java
 *
 * Created on 9. syyskuuta 2004, 13:02
 */

package kumbang.configurator.client.gui.tree;

import kumbang.util.gui.Icons;

import kumbang.core.configuration.instance.BindingInstance;
import kumbang.core.configuration.instance.InterfaceInstance;
import kumbang.core.configuration.instance.Instance;

/**
 *
 * @author  vmyllarn
 */
public class BindingNode extends ConfigurationNode implements InstanceNode {
    
    private BindingInstance binding;
    
    private InterfaceInstance interf;
    
    private String text;
    
    /** Creates a new instance of BindingNode */
    public BindingNode(BindingInstance binding, InterfaceInstance interf) {
        super(binding, Icons.BINDING_SOURCE, Icons.BINDING_SOURCE_L);
        this.binding = binding;
        this.interf = interf;
        if (binding.getTargetInterface().equals(interf)) {
            setSmallIcon(Icons.BINDING_TARGET);
            setLargeIcon(Icons.BINDING_TARGET_L);
            this.text  
                    = binding.getSourceInterface().getParent().toString() 
                    + " . " + binding.getSourceInterface().toString();
        } else {
            this.text 
                = binding.getTargetInterface().getParent().toString() 
                + " . " + binding.getTargetInterface().toString();
        }
    }
    
    public Instance getInstance() {
        return this.binding;
    }
    
    public BindingInstance getBindingInstance() {
        return this.binding;
    }
    
    public InterfaceInstance getInterfaceInstance() {
        return this.interf;
    }
    
    public String toString() {
        return this.text;
    }
}
