/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * ComponentNode.java
 *
 * Created on 24. helmikuuta 2004, 10:30
 */

package kumbang.configurator.client.gui.tree;

import kumbang.util.gui.Icons;

import kumbang.core.configuration.instance.ComponentInstance;
import kumbang.core.configuration.instance.Instance;


/**
 *
 * @author  vmyllarn
 */
public class ComponentNode extends ConfigurationNode implements InstanceNode {
    
    private ComponentInstance instance;
    
    /** Creates a new instance of ComponentNode */
    public ComponentNode(ComponentInstance instance) {
        super(instance, Icons.COMPONENT, Icons.COMPONENT_L);
        this.instance = instance;
    }
    
    public Instance getInstance() {
        return this.instance;
    }
    
    public ComponentInstance getComponentInstance() {
        return this.instance;
    }
    
    public String toString() {
        return instance.toString();
    }
}
