/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * FeatureNode.java
 *
 * Created on 23. helmikuuta 2004, 14:40
 */

package kumbang.configurator.client.gui.tree;

import kumbang.util.gui.Icons;

import kumbang.core.configuration.instance.FeatureInstance;
import kumbang.core.configuration.instance.Instance;

/**
 * 
 * @author vmyllarn
 */
public class FeatureNode extends ConfigurationNode implements InstanceNode {

	private FeatureInstance instance;

	/** Creates a new instance of FeatureNode */
	public FeatureNode(FeatureInstance instance) {
		super(instance, Icons.FEATURE, Icons.FEATURE_L);
		this.instance = instance;

		/*
		 * TODO Does it really make sense to consider a feature instance to be optional? I somehow
		 * understand referring to the optionality of a PartInstance. But a feature either is or is
		 * not in a configuration, there's nothing optional about it. -toasikai
		 */
//		if (instance.isOptional()) {
//			setSmallIcon(Icons.FEATURE_OPTIONAL);
//			setLargeIcon(Icons.FEATURE_OPTIONAL_L);
//		} else {
		setSmallIcon(Icons.FEATURE_MANDATORY);
		setLargeIcon(Icons.FEATURE_MANDATORY_L);
//		}
	}

	public Instance getInstance() {
		return this.instance;
	}

	public FeatureInstance getFeatureInstance() {
		return this.instance;
	}

	public String toString() {
		return instance.toString();
	}
}
