/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * PartNode.java
 *
 * Created on 9. syyskuuta 2004, 12:43
 */

package kumbang.configurator.client.gui.tree;

import kumbang.util.gui.Icons;

import kumbang.core.configuration.instance.FeatureInstance;
import kumbang.core.configuration.instance.Instance;
import kumbang.core.configuration.instance.PartInstance;

/**
 *
 * @author  vmyllarn
 */
public class PartNode extends ConfigurationNode implements InstanceNode {
    
    private PartInstance instance;
    
    /** Creates a new instance of PartNode */
    public PartNode(PartInstance instance) {
        super(instance, Icons.PART, Icons.PART_L);
        this.instance = instance;
        if (instance.getParent() instanceof FeatureInstance) {
            setSmallIcon(Icons.SUBFEATURE_ROLE);
            setLargeIcon(Icons.SUBFEATURE_ROLE_L);
        }
    }
    
    public Instance getInstance() {
        return this.instance;
    }
    
    public PartInstance getPartInstance() {
        return this.instance;
    }
    
    public String toString() {
        return instance.toString();
    }
}
