/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


package kumbang.configurator.client.plugin;

import java.io.File;

import kumbang.configurator.client.core.ClientServices;
import kumbang.configurator.client.plugin.event.ConfigurationModificationListener;
import kumbang.configurator.client.plugin.event.ConfigurationOpenedClosedListener;
import kumbang.configurator.client.plugin.event.ConfigurationSaveListener;
import kumbang.core.configuration.task.ClientTask;

import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.jface.resource.ColorRegistry;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.ui.IWorkbench;

public interface IKumbangPlugin {

    public ImageRegistry getImageRegistry();
    
    public String getPluginDir();
    public String getPluginDir(String name);
    public String getPluginID();
    public boolean isUMLPreferenceSet();
    public boolean showCompletenessPopups();
//    public ClientServices getClientServices();
    public String getSaveLocation();
//    public boolean isServerAvailable();
//    public void openKumbangPerspective();
    public ColorRegistry getColorRegistry();
    public ImageDescriptor getImageDescriptor(String name);
    public IPreferenceStore getPreferenceStore();
//    public void addConfigurationModificationListener(ConfigurationModificationListener listener);
//    public void removeConfigurationModificationListener(ConfigurationModificationListener listener);
//    public void addOpenCloseListener(ConfigurationOpenedClosedListener l);
//    public void removeOpenCloseListener(ConfigurationOpenedClosedListener l);
//    public void addSaveListener(ConfigurationSaveListener l);
//    public void removeSaveListener(ConfigurationSaveListener l);
//    public void fireOpenCloseEvent(String eventType);
//    public void fireConfigurationModifiedEvent(ClientTask task);
//    public void fireSaveEvent(File saveFile);
    public PluginHandler getHandler();

	public IWorkbench getWorkbench();

}
