/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


package kumbang.configurator.client.plugin.actions;

import kumbang.configurator.Activator;
import kumbang.configurator.client.plugin.KumbangConfiguratorPlugin;
import kumbang.configurator.client.plugin.wizards.InitWizard;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;

/**
 * Action for launching the Kumbang Model Initialization Wizard
 * from the toolbar or menu
 * @author jlemmett
 *
 */
public class InitConfiguration implements IWorkbenchWindowActionDelegate {

	private IStructuredSelection selection;
	
	public void dispose() {
		

	}

	public void init(IWorkbenchWindow window) {
		
		
	}

	public void run(IAction action) {
		
		if (Activator.getDefault().getHandler().isServerAvailable()) {
			// Create the wizard
			InitWizard wizard = new InitWizard();
			wizard.init(Activator.getDefault().getWorkbench(), selection);
			
			// Create the wizard dialog
			WizardDialog dialog = new WizardDialog
			(Activator.getDefault().getWorkbench().getActiveWorkbenchWindow().getShell(),wizard);
			// Open the wizard dialog
			
			// TODO: Figure out the proper dialog size
			
			//dialog.setPageSize(525,400);
			
			//dialog.set
			dialog.create();
			dialog.open();
		} else {
			MessageDialog.openError(Activator.getDefault().getWorkbench().getActiveWorkbenchWindow().getShell(), "Server not available", "The configuration server is not available, please start it first.");
		}
	}

	public void selectionChanged(IAction action, ISelection selection) {

	}

}
