/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


package kumbang.configurator.client.plugin.dialogs;


import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;

import kumbang.core.configuration.instance.ComposableInstance;
import kumbang.core.configuration.instance.InterfaceInstance;

/**
 * Helps in creating consistent GUI-dialogs.
 *
 */
public class DialogHelper {

	private DialogHelper() {
		super();
	}

    public static Group getInfoComponent(Composite parent, ComposableInstance instance) {
        if (instance == null) {
            return getInfoComponent(parent, "", "", "", "");
        } else if (instance.getParent() != null) {
            return getInfoComponent(parent, instance.getDisplayName(), 
                    instance.getType().getDisplayName(), 
                    instance.getParent().getDisplayName(),
                    instance.getParent().getType().getDisplayName());
        } else {
            return getInfoComponent(parent, instance.getDisplayName(), 
                                    instance.getType().getDisplayName(), 
                                    "", "");
        }
    }
    
    public static Group getInfoComponent(Composite parent, InterfaceInstance instance) {
        if (instance == null) {
            return getInfoComponent(parent, "", "", "", "");
        } else if (instance.getParent() != null) {
            return getInfoComponent(parent, instance.getDisplayName(), 
                    instance.getType().getDisplayName(), 
                    instance.getParent().getDisplayName(),
                    instance.getParent().getType().getDisplayName());
        } else {
            return getInfoComponent(parent, instance.getDisplayName(), 
                                    instance.getType().getDisplayName(), 
                                    "", "");
        }
    }
    
    public static Group getInfoComponent(Composite parent, String name, String type, 
                                       String parentName, String parentType) {
    
        Group group = new Group(parent, SWT.SHADOW_ETCHED_IN);
        GridLayout gl = new GridLayout(2, false);
        group.setLayout(gl);
		Label lbl = new Label(group, SWT.NONE);
		lbl.setText("Name:");
		lbl = new Label(group, SWT.NONE);
		lbl.setText(name);
		lbl = new Label(group, SWT.NONE);
		lbl.setText("Type:");
		lbl = new Label(group, SWT.NONE);
		lbl.setText(type);
		lbl = new Label(group, SWT.NONE);
		lbl.setText("Parent name:");
		lbl = new Label(group, SWT.NONE);
		lbl.setText(parentName);
		lbl = new Label(group, SWT.NONE);
		lbl.setText("Parent type:");
		lbl = new Label(group, SWT.NONE);
		lbl.setText(parentType);
		return group;
    }

	
}
