/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


package kumbang.configurator.client.plugin.dialogs;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Layout;

/**
 * This class is for setting the layouts for the dialogs
 */
public class DialogLayout {

	private static final int dialogSize = 650; 
	
	public static final int MARGIN_INNER = 1;
	
	public static final int DIALOG_MIN_WIDTH = 550;
	
	public static final int DIALOG_MIN_HEIGHT = 340;
	
	public DialogLayout() {
		super();
	}

	public static Layout innerCompositeLayout() { 
	GridLayout gl = new GridLayout(2, false);
	gl.marginWidth = 10;
	gl.marginLeft = 10;
	gl.horizontalSpacing = 20;
	gl.verticalSpacing = 10;
	
	return gl;
	}
	
	public static GridData logoLayoutData() {
		
		GridData gridData = new GridData(GridData.FILL_HORIZONTAL);
		gridData.verticalSpan = 2;
		gridData.verticalAlignment = SWT.TOP;
		gridData.horizontalAlignment = SWT.RIGHT;
		
		return gridData;
	}
	
	public static Layout exportCompositeLayout() {
		GridLayout gl = new GridLayout(2, false);
		gl.marginWidth = 10;
		gl.marginLeft = 10;
		gl.horizontalSpacing = 20;
		gl.verticalSpacing = 10;
		
		return gl;
	}
}
