/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


package kumbang.configurator.client.plugin.properties;

import kumbang.core.configuration.instance.AttributeInstance;

import org.eclipse.ui.views.properties.IPropertyDescriptor;
import org.eclipse.ui.views.properties.IPropertySource;
import org.eclipse.ui.views.properties.PropertyDescriptor;

public class AttributePropertySource implements IPropertySource {

	private static final String NAME_ID = "attribute.name";
	private static final String VALUE_ID = "attribute.value";
	
	private IPropertyDescriptor[] propertyDescriptors;
	
	private AttributeInstance aInstance;
	
	public AttributePropertySource(AttributeInstance instance) {
		super();
		this.aInstance = instance;
	}

	public Object getEditableValue() {
		// TODO Auto-generated method stub
		return null;
	}

	public IPropertyDescriptor[] getPropertyDescriptors() {
		if (propertyDescriptors == null) {
			PropertyDescriptor nameDescriptor = new PropertyDescriptor(NAME_ID, "1. Attribute name");
			PropertyDescriptor valueDescriptor = new PropertyDescriptor(VALUE_ID, "2. Attribute value");
			propertyDescriptors = new IPropertyDescriptor[] {
					nameDescriptor,
					valueDescriptor};
		}
		return propertyDescriptors;
	}

	public Object getPropertyValue(Object id) {
		if (NAME_ID.equals(id)) {
			return aInstance.getName();
		}
		
		if (VALUE_ID.equals(id)) {
			return aInstance.getValue();
		}
		return null;
	}

	public boolean isPropertySet(Object id) {
		// TODO Auto-generated method stub
		return false;
	}

	public void resetPropertyValue(Object id) {
		// TODO Auto-generated method stub

	}

	public void setPropertyValue(Object id, Object value) {
		// TODO Auto-generated method stub

	}

}
