/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


package kumbang.configurator.client.plugin.properties;

import kumbang.core.configuration.instance.BindingInstance;

import org.eclipse.ui.views.properties.IPropertyDescriptor;
import org.eclipse.ui.views.properties.IPropertySource;
import org.eclipse.ui.views.properties.PropertyDescriptor;

public class BindingPropertySource implements IPropertySource {

	private static final String SOURCE_ID = "binding.source";
	private static final String TARGET_ID = "binding.target";
	
	private IPropertyDescriptor[] propertyDescriptors; 
	
	private BindingInstance bInstance;
	
	public BindingPropertySource(BindingInstance instance) {
		super();
		this.bInstance = instance;
	}

	public Object getEditableValue() {
		// TODO Auto-generated method stub
		return null;
	}

	public IPropertyDescriptor[] getPropertyDescriptors() {
		if (propertyDescriptors == null) {
			PropertyDescriptor sourceDescriptor = new PropertyDescriptor(SOURCE_ID, "1. Binding Source Interface");
			PropertyDescriptor targetDescriptor = new PropertyDescriptor(TARGET_ID, "2. Binding Target Interface");
			propertyDescriptors = new IPropertyDescriptor[] {
					sourceDescriptor,
					targetDescriptor};
		}
		return propertyDescriptors;
	}

	public Object getPropertyValue(Object id) {
		if (SOURCE_ID.equals(id)) {
			// TODO Check if this makes sense. -toasikai
			return bInstance.getSourceInterface(); //  + ", " + bInstance.getSourceID();
		}
		
		if (TARGET_ID.equals(id)) {
			// TODO Check if this makes sense. -toasikai			
			return bInstance.getTargetInterface(); // + ", " + bInstance.getTargetID();
		}
		
		return null;
	}

	public boolean isPropertySet(Object id) {
		// TODO Auto-generated method stub
		return false;
	}

	public void resetPropertyValue(Object id) {
		// TODO Auto-generated method stub

	}

	public void setPropertyValue(Object id, Object value) {
		// TODO Auto-generated method stub

	}

}
