/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


package kumbang.configurator.client.plugin.tree;

import java.util.List;

import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.views.properties.IPropertySource;

import kumbang.configurator.client.plugin.Icons;
import kumbang.configurator.client.plugin.KumbangConfiguratorPlugin;
import kumbang.configurator.client.plugin.PluginHandler;
import kumbang.configurator.client.plugin.properties.AttributePropertySource;
import kumbang.core.configuration.instance.AttributeInstance;
import kumbang.core.configuration.instance.Instance;

public class AttributeNode extends TreeNode {

	private AttributeInstance aInstance;
	private Object pSource;
	
	public AttributeNode(ITreeNode parent, AttributeInstance attribute) {
		super(parent);
		aInstance = attribute;
	}
	
	public String getName() {
		return aInstance.toString();
	}
	
	public Image getImage() {
		return PluginHandler.getActivator().getImageRegistry().get(Icons.ATTRIBUTE); 
	}
	
	public Instance getInstance() {
		return this.aInstance;
	}
	
	public boolean equals(Object obj) {
		if (obj instanceof AttributeNode)
			return getName().equals(((AttributeNode)obj).getName());
		else
			return false;
	}
	
	// Attributes don't have children
	public boolean hasChildren() {
		return false; 
	}

	//Attributes don't have children
	protected void createChildren(List children) {
	}

	public Object getAdapter(Class adapter) {
		if (adapter == IPropertySource.class) {
			if (pSource == null) {
				// XXX: potential problem source !!
				this.pSource = new AttributePropertySource(aInstance);
			}
			return pSource;
		}
		return null;
	}
	
    
    
}
