/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


package kumbang.configurator.client.plugin.tree;

import java.util.List;

import kumbang.configurator.client.plugin.Icons;
import kumbang.configurator.client.plugin.KumbangConfiguratorPlugin;
import kumbang.configurator.client.plugin.PluginHandler;
import kumbang.core.configuration.instance.Instance;

import org.eclipse.swt.graphics.Image;

public class RootNode extends TreeNode {

	private ITreeNode TreeRoot;
	
	public RootNode() {
		super(null);
	}

	public void hookTreeRoot(ITreeNode root) {
		this.TreeRoot = root;
	}
	
	protected void createChildren(List children) {
		children.add(TreeRoot);

	}

	public boolean equals(Object obj) {
		if(obj instanceof RootNode) {
			return true;
		}
		else
			return false;
	}
	
	public String getName() {
		return TreeRoot.getName();
	}
	
	public Image getImage() {
		return PluginHandler.getActivator().getImageRegistry().get(Icons.ATTRIBUTE); 
	}

	public Object getAdapter(Class adapter) {
		// No info on root node
		return null;
	}
    
    public Instance getInstance() {
        return null;
    }
}
