/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


package kumbang.configurator.client.plugin.tree;

import java.util.ArrayList;
import java.util.List;

import kumbang.configurator.client.plugin.IKumbangPlugin;
import kumbang.configurator.client.plugin.KumbangConfiguratorPlugin;
import kumbang.core.configuration.instance.Instance;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.swt.graphics.Image;

/** Default or adapter implementation for ITreeNode
 * 
 * @author jlemmett
 *
 */
public abstract class TreeNode implements ITreeNode, IAdaptable {

	protected ITreeNode parent;
	protected List children;
	
	public TreeNode(ITreeNode parent) {
		this.parent = parent;
	}

	public Image getImage() {
		return null;
	}
	
	public boolean hasChildren() {
		return true;
	}
	
	public ITreeNode getParent() {
		return parent;
	}
	
	
	public List getChildren() {
		// TODO: TreeViewer.refresh() won't work properly with these...
		//if (this.children != null) 
		//	return this.children;
		
		children = new ArrayList();
		createChildren(children);
		return children;
	}
	
	/* subclasses should override these methods and add the child nodes */
	protected abstract void createChildren(List children);
    public abstract Instance getInstance();
    public abstract boolean equals(Object obj);
    
 
	
}
