/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * Session.java
 *
 * Created on 18. huhtikuuta 2004, 18:23
 */

package kumbang.configurator.server.services;

import kumbang.configurator.server.core.ConfigurationHandler;

/**
 *
 * @author  Administrator
 */
public class Session {
    
    private int id;
    
    private long timestamp;
    
    private ConfigurationHandler handler;
    
    //private SmConfigurationHandler smHandler;
    
    private RemoteSession remoteSession;
    
    /** Creates a new instance of Session */
    public Session(int id) {
        this.id = id;
        this.handler = new ConfigurationHandler(KumbangConfigurationServer.logger);
        this.remoteSession = new RemoteSession(id);
        refresh();
    }
    
    public int getID() {
        return this.id;
    }
    
    public RemoteSession getRemoteSession() {
        return this.remoteSession;
    }
    
    public ConfigurationHandler getConfiguration() {
        return this.handler;
    }
    
    //public SmConfigurationHandler getSmodelsConfiguration() {
    //    return this.smHandler;
    //}
    
    public void refresh() {
        timestamp = System.currentTimeMillis();
    }
    
    public boolean equals(Object o) {
        if (o instanceof Session) {
            return ((Session)o).getID() == id;
        }
        else {
            return false;
        }
    }
    
    public String toString() {
        return "session:"+this.id;
    }
}
