/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * InitConfigurationTester.java
 *
 * Created on 30. maaliskuuta 2004, 16:50
 */

package kumbang.configurator.util.test;

import kumbang.core.configuration.core.Configuration;

import kumbang.core.language.parser.ModelParser;

import kumbang.core.model.exception.ModelException;


import java.io.*;


/**
 * Is this class used? -toasikai 2.6.2005
 * 
 * @author vmyllarn
 */
public class InitConfigurationTester {

	/**
	 * @param args the command line arguments
	 */
	public static void main(String[] args) throws IOException {

		String inputFile = null;

		if (args.length == 0) {
			System.out.print("Give name of the input file: ");
			BufferedReader buf = new BufferedReader(new InputStreamReader(System.in));
			inputFile = buf.readLine();
		} else {
			inputFile = args[0];
		}
		if (inputFile == null) {
			return;
		}


		ModelParser modelParser = new ModelParser();

		try {
			new Configuration(modelParser.parseModel(new File(inputFile)));
		} catch (ModelException ce) {
			System.out.println("Configuration exception: " + ce.getMessage());
			ce.printStackTrace();
		}
	}

}
