/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * FeatureInstance.java
 *
 * Created on 2. maaliskuuta 2004, 12:18
 */

package kumbang.core.configuration.instance;

import kumbang.core.model.type.FeatureType;

/**
 *
 * @author  vmyllarn
 */
public class FeatureInstance extends ComposableInstance {
    
    /** 
     * Creates a new instance of FeatureInstance that is an 
     * exact copy of the given instance under the given parent.
     */
    public FeatureInstance(FeatureType type, PartInstance parent, boolean userAdded) {
        super(type, parent, userAdded);
    }
    
    /** 
     * Creates a new instance of FeatureInstance hat is the root component 
     * and is an exact copy of the given instance.
     */
    public FeatureInstance(FeatureType type) {
        this(type, null, false);
    }
    
//	public FeatureInstance(ComposableInstance parent, FeatureInstance instance) {
//		super(parent, instance);
//	}

	public FeatureType getFeatureType() {
        return (FeatureType) getType();
    }
    
    public String getInstanceKind() {
        return "feature";
    }
}
