/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


package kumbang.core.configuration.reference;

/**
 * 
 * @author toasikai
 */
public class AttributeReference implements Reference {
	private ComposableReference ref;
	private String name;
	private String value;
	
	public AttributeReference(ComposableReference comp, String attr) {
		this(comp, attr, null);
	}
	
	public AttributeReference(ComposableReference comp, String attr, String value) {
		this.ref = comp;
		this.name = attr;
		
		if (value.length() > 0)
			this.value = value;
		else
			this.value = null;
	}

	public boolean isComponentReference() {
		return ref.isComponentReference();
	}

	public ComposableReference getComposable() {
		return ref;
	}
	
	public String getName() {
		return name;
	}
	
	public String getValue() {
		return value;
	}
	
	public String toString() {
		return "AttributeReference[" + name + "]";
	}
}
