/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


package kumbang.core.configuration.reference;

/**
 * 
 * @author toasikai
 */
public class BindingReference implements Reference {
	private InterfaceReference source;
	private InterfaceReference target;
	
	public BindingReference(ComposableReference comp, String sourceInt, String sourceType,
			ComposableReference targetComp, String targetInt, String targetType) {
		source = new InterfaceReference(comp, sourceInt, sourceType);
		target = new InterfaceReference(targetComp, targetInt, targetType);
	}
	
	public BindingReference(InterfaceReference source, InterfaceReference target) {
		this.source = source;
		this.target = target;
	}

	public boolean isComponentReference() {
		return true;
	}

	public ComposableReference getComposable() {
		throw new Error("BindingReference objects don't have a unique ComposableRefeference.");
	}
	
	public InterfaceReference getSource() {
		return source;
	}
	
	public InterfaceReference getTarget() {
		return target;
	}
	
	public String toString() {
		return "BindingReference[" + source.getName() + "-" + target.getName() + "]";
	}
}
