/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


package kumbang.core.configuration.reference;

/**
 * 
 * @author toasikai
 */
public class InterfaceReference implements Reference {
	private ComposableReference ref;
	private String interfaceName;
	private String type;
	
	public InterfaceReference(ComposableReference comp, String sourceInt, String type) {
		this.ref = comp;
		this.interfaceName = sourceInt;
		this.type = type;
	}

	public InterfaceReference(ComposableReference parent, String name) {
		this.ref = parent;
		this.interfaceName = name;
	}

	public boolean isComponentReference() {
		return true;
	}
	
	public ComposableReference getComposable() {
		return ref;
	}

	public String getName() {
		return interfaceName;
	}

	public Object getType() {
		return type;
	}
	
	public String toString() {
		return "InterfaceReference[" + interfaceName + "]";
	}
}
