/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


package kumbang.core.configuration.reference;

import java.io.Serializable;

import kumbang.core.model.type.ElementaryType;

/**
 * Represents an individual node in a Reference object. 
 * 
 * @author toasikai
 */
public class ReferenceItem implements Serializable {
	private String partName;
	private String typeName;
	private int index;
	
	public ReferenceItem(String partName, int index, String typeName) {
		this.partName = partName;
		this.index = index;
		this.typeName = typeName;
	}

	public ReferenceItem(String name) {
		this.partName = name;
		this.index = -1;
	}

	public String getName() {
		return partName;
	}

	public String getType() {
		return typeName;
	}

	public int getIndex() {
		return index;
	}
}
