/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * AddInstanceTask.java
 *
 * Created on 25. lokakuuta 2004, 14:36
 */

package kumbang.core.configuration.task;

import kumbang.core.configuration.instance.Instance;

/**
 *
 * @author  vmyllarn
 */
public abstract class AddInstanceTask extends ClientTask {
      
    /** instance after it has been added */
    private Instance addedInstance;
    
    /**
     * Creates a new instance of AddInstanceTask 
     * @param parent parent client task
     */
    public AddInstanceTask(ClientTask parent, boolean isUserTask) {
        super(parent, isUserTask);
    }
    
    /**
     * Returns the newly added instance
     * @return Instance
     */
    public Instance getAddedInstance() {
        return addedInstance;
    }
    
    /**
     * Sets the newly added instance
     * @param instance
     */
    public /*protected*/ void setAddedInstance(Instance instance) {
        this.addedInstance = instance;
    }
}
