/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * AddInterfaceTask.java
 *
 * Created on 19. lokakuuta 2004, 13:07
 */

package kumbang.core.configuration.task;

import kumbang.core.configuration.instance.InterfaceInstance;
import kumbang.core.model.type.InterfaceDefinition;
import kumbang.core.model.type.InterfaceType;

/**
 * 
 * @author  vmyllarn
 */
public class AddInterfaceTask extends AddInstanceTask {
	private InterfaceDefinition def;
	private InterfaceType type;

	/**
	 * Creates a new AddInterfacesTask. The created task will always have a parent task,
	 * either a AddComposableTask or an EditComposableTask.
	 * 
	 * @param parent
	 * @param def
	 * @param type
	 */
	public AddInterfaceTask(ClientTask parent, InterfaceDefinition def, InterfaceType type) {
		super(parent, parent.isUserTask());
		
		this.def = def;
		this.type = type;
	}
    
	public InterfaceDefinition getDefininition() {
		return def;
	}
	
	public InterfaceType getType() {
		return type;
	}
	
	public InterfaceInstance getAddedInterface() {
		return (InterfaceInstance) getAddedInstance(); 
	}
	
	public void setAttributeValue(String name, String value) {
		addSubTask(new SetAttributeTask(this, name, value));
	}
	
	public String toString() {
		return "AddInterfaceTask[" + def.getName() + "." + type + "]";
	}	
}	
