/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * ConfigurationConsequence.java
 *
 * Created on 22. kes�kuuta 2004, 13:49
 */

package kumbang.core.configuration.task;

import java.io.Serializable;

/**
 * Consequences of the current configuration. Consequences are either positive (it must exist in the
 * configuration) or negative (it must not exits in the configuration). These are part of the
 * configuration response.
 * 
 * @author vmyllarn
 */
public abstract class ConfigurationConsequence implements Serializable, Comparable {
	private int targetID;

	public ConfigurationConsequence(int targetID) {
		this.targetID = targetID;
	}

	public int getTargetID() {
		return targetID;
	}

	public String toString() {
		return "ConfigurationConsequence[" + getTargetID() + "]";
	}

	public abstract int compareTo(Object o);
//		ConfigurationConsequence c = (ConfigurationConsequence) o;
//		return targetID - c.getTargetID();
//	}
}
