/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * ConfigurationInstanceConsequence.java
 *
 * Created on 31. elokuuta 2004, 6:24
 */

package kumbang.core.configuration.task;

/**
 * 
 * @author vmyllarn
 */
public class InstanceExistsConsequence extends ConfigurationConsequence {

	/** Creates a new instance of ConfigurationInstanceStatement */
	public InstanceExistsConsequence(int targetID) {
		super(targetID);
	}

	public String toString() {
		return "InstanceExistsConsequence[" + getTargetID() + "]";
	}

	public boolean equals(Object o) {
		if (o instanceof InstanceExistsConsequence) {
			return ((InstanceExistsConsequence) o).getTargetID() == getTargetID();
		}
		return false;
	}

	public int compareTo(Object o) {
		// Only ConfigurationConsequences can be compared with each other.
		if (!(o instanceof ConfigurationConsequence))
			throw new ClassCastException();
		
		// InterfacesBoundConsequence come after InstanceExistConsequence objects.
		if (!(o instanceof InstanceExistsConsequence))
			return -1;
		
		// Ordering based on the target id's is arbitrary.
		return getTargetID() - ((ConfigurationConsequence) o).getTargetID();
		
//		int ret = super.compareTo(o);
//		if (o instanceof InstanceExistsConsequence) {
//			return ret;
//		} else {
//			return -1;
//		}
	}
}
