/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


//
// Generated by JTB 1.2.2
//

package kumbang.core.language.visitor;
import kumbang.core.language.syntaxtree.*;
import java.util.*;

/**
 * Provides default methods which visit each node in the tree in depth-first
 * order.  Your visitors may extend this class.
 */
public class ObjectDepthFirst implements ObjectVisitor {
   //
   // Auto class visitors--probably don't need to be overridden.
   //
   public Object visit(NodeList n, Object argu) {
      Object _ret=null;
      int _count=0;
      for ( Enumeration e = n.elements(); e.hasMoreElements(); ) {
         ((Node)e.nextElement()).accept(this,argu);
         _count++;
      }
      return _ret;
   }

   public Object visit(NodeListOptional n, Object argu) {
      if ( n.present() ) {
         Object _ret=null;
         int _count=0;
         for ( Enumeration e = n.elements(); e.hasMoreElements(); ) {
            ((Node)e.nextElement()).accept(this,argu);
            _count++;
         }
         return _ret;
      }
      else
         return null;
   }

   public Object visit(NodeOptional n, Object argu) {
      if ( n.present() )
         return n.node.accept(this,argu);
      else
         return null;
   }

   public Object visit(NodeSequence n, Object argu) {
      Object _ret=null;
      int _count=0;
      for ( Enumeration e = n.elements(); e.hasMoreElements(); ) {
         ((Node)e.nextElement()).accept(this,argu);
         _count++;
      }
      return _ret;
   }

   public Object visit(NodeToken n, Object argu) { return null; }

   //
   // User-generated visitor methods below
   //

   /**
    * f0 -> SyntaxModelKind()
    * f1 -> <MODEL>
    * f2 -> <IDENTIFIER>
    * f3 -> ( <ROOT> ( <FEATURE> | <COMPONENT> ) <IDENTIFIER> )+
    * f4 -> ( SyntaxTypeDefinition() )*
    */
   public Object visit(SyntaxModel n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <FORFAMEL>
    *       | <KOALISH>
    *       | <KUMBANG>
    */
   public Object visit(SyntaxModelKind n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> SyntaxAttributeTypeDefinition()
    *       | SyntaxInterfaceTypeDefinition()
    *       | SyntaxComposableTypeDefinition()
    */
   public Object visit(SyntaxTypeDefinition n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> [ <ABSTRACT> ]
    * f1 -> ( <FEATURE> | <COMPONENT> )
    * f2 -> <TYPE>
    * f3 -> SyntaxDisplayIdentifier()
    * f4 -> [ <EXTENDS> SyntaxIdentifierList() ]
    * f5 -> <LBRACE>
    * f6 -> ( SyntaxSection() )*
    * f7 -> <RBRACE>
    */
   public Object visit(SyntaxComposableTypeDefinition n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      n.f6.accept(this, argu);
      n.f7.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <ATTRIBUTE>
    * f1 -> <TYPE>
    * f2 -> SyntaxDisplayIdentifier()
    * f3 -> <EQUALS>
    * f4 -> <LBRACE>
    * f5 -> SyntaxValueEnumeration()
    * f6 -> <RBRACE>
    */
   public Object visit(SyntaxAttributeTypeDefinition n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      n.f6.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <INTERFACE>
    * f1 -> <TYPE>
    * f2 -> SyntaxDisplayIdentifier()
    * f3 -> <LBRACE>
    * f4 -> ( <IDENTIFIER> <SEMICOLON> )*
    * f5 -> <RBRACE>
    */
   public Object visit(SyntaxInterfaceTypeDefinition n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> SyntaxSubfeatureSection()
    *       | SyntaxAttributeSection()
    *       | SyntaxProvideSection()
    *       | SyntaxRequireSection()
    *       | SyntaxConstraintSection()
    *       | SyntaxContainSection()
    *       | SyntaxConnectSection()
    *       | SyntaxImplementationSection()
    */
   public Object visit(SyntaxSection n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <SUBFEATURES>
    * f1 -> ( SyntaxPartSpecification() )*
    */
   public Object visit(SyntaxSubfeatureSection n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <ATTRIBUTES>
    * f1 -> ( SyntaxAttribute() )*
    */
   public Object visit(SyntaxAttributeSection n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <PROVIDES>
    * f1 -> ( SyntaxInterface() )*
    */
   public Object visit(SyntaxProvideSection n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <REQUIRES>
    * f1 -> ( SyntaxInterface() )*
    */
   public Object visit(SyntaxRequireSection n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> SyntaxIdentifierList()
    * f1 -> SyntaxInterfaceSpecification()
    * f2 -> ( <COMMA> SyntaxInterfaceSpecification() )*
    * f3 -> <SEMICOLON>
    */
   public Object visit(SyntaxInterface n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> SyntaxDisplayIdentifier()
    * f1 -> [ <LBRACE> ( <OPTIONAL> | <GROUNDED> ) [ <COMMA> ( <OPTIONAL> | <GROUNDED> ) ] <RBRACE> ]
    */
   public Object visit(SyntaxInterfaceSpecification n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <CONSTRAINTS>
    * f1 -> ( SyntaxConstraint() )*
    */
   public Object visit(SyntaxConstraintSection n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <CONTAINS>
    * f1 -> ( SyntaxPartSpecification() )*
    */
   public Object visit(SyntaxContainSection n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <IMPLEMENTATION>
    * f1 -> ( SyntaxConstraint() )*
    */
   public Object visit(SyntaxImplementationSection n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> SyntaxIdentifierList()
    * f1 -> SyntaxDisplayIdentifier()
    * f2 -> [ SyntaxCardinality() ]
    * f3 -> [ <LBRACE> ( <NONE> | <SAME> | <DIFFERENT> ) <RBRACE> ]
    * f4 -> <SEMICOLON>
    */
   public Object visit(SyntaxPartSpecification n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <IDENTIFIER>
    *       | <LPAREN> <IDENTIFIER> ( SyntaxIdentifierListEnd() )* <RPAREN>
    */
   public Object visit(SyntaxIdentifierList n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <COMMA>
    * f1 -> <IDENTIFIER>
    */
   public Object visit(SyntaxIdentifierListEnd n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <LBRACKET>
    * f1 -> <INTEGER_LITERAL>
    * f2 -> [ <MINUS> <INTEGER_LITERAL> ]
    * f3 -> <RBRACKET>
    */
   public Object visit(SyntaxCardinality n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <IDENTIFIER>
    * f1 -> SyntaxDisplayIdentifier()
    * f2 -> [ <LBRACE> <HIDDEN> <RBRACE> ]
    * f3 -> <SEMICOLON>
    */
   public Object visit(SyntaxAttribute n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> SyntaxValueDefinition()
    * f1 -> ( SyntaxEnumerationRest() )*
    */
   public Object visit(SyntaxValueEnumeration n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> ( [ <MINUS> ] <INTEGER_LITERAL> | <IDENTIFIER> )
    * f1 -> [ <STRING_LITERAL> ]
    */
   public Object visit(SyntaxValueDefinition n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> [ <MINUS> ] <INTEGER_LITERAL>
    *       | <IDENTIFIER>
    */
   public Object visit(SyntaxValue n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <COMMA>
    * f1 -> SyntaxValueDefinition()
    */
   public Object visit(SyntaxEnumerationRest n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <IDENTIFIER>
    */
   public Object visit(SyntaxFunction n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <CONNECTS>
    * f1 -> ( SyntaxConnection() )*
    */
   public Object visit(SyntaxConnectSection n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <IDENTIFIER>
    * f1 -> [ <DOT> <IDENTIFIER> ]
    * f2 -> <EQUALS>
    * f3 -> <IDENTIFIER>
    * f4 -> [ <DOT> <IDENTIFIER> ]
    * f5 -> <SEMICOLON>
    */
   public Object visit(SyntaxConnection n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> SyntaxEquivalenceExpression()
    * f1 -> <SEMICOLON>
    */
   public Object visit(SyntaxConstraint n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> [ <NOT> ]
    * f1 -> ( <FORALL> | <EXISTS> )
    * f2 -> <LPAREN>
    * f3 -> SyntaxVariableBinding()
    * f4 -> ( <COMMA> SyntaxVariableBinding() )*
    * f5 -> <RPAREN>
    */
   public Object visit(SyntaxQuantification n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <IDENTIFIER>
    * f1 -> <COLON>
    * f2 -> SyntaxStructureReference()
    */
   public Object visit(SyntaxVariableBinding n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> SyntaxImplicationExpression()
    * f1 -> [ <EQUIVALENT> SyntaxImplicationExpression() ]
    */
   public Object visit(SyntaxEquivalenceExpression n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> SyntaxAndOrExpression()
    * f1 -> [ <IMPLIES> SyntaxAndOrExpression() ]
    */
   public Object visit(SyntaxImplicationExpression n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> SyntaxQuantifiedExpression()
    * f1 -> ( ( <AND> | <OR> ) SyntaxQuantifiedExpression() )*
    */
   public Object visit(SyntaxAndOrExpression n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> ( SyntaxQuantification() )*
    * f1 -> [ <NOT> ]
    * f2 -> ( SyntaxConfigurationPredicateExpression() | SyntaxComparisonExpression() )
    */
   public Object visit(SyntaxQuantifiedExpression n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> SyntaxAdditiveExpression()
    * f1 -> [ SyntaxComparisonOperator() SyntaxAdditiveExpression() ]
    */
   public Object visit(SyntaxComparisonExpression n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> SyntaxMultiplicativeExpression()
    * f1 -> ( ( <PLUS> | <MINUS> ) SyntaxMultiplicativeExpression() )*
    */
   public Object visit(SyntaxAdditiveExpression n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> SyntaxPrimitiveArithmetic()
    * f1 -> ( ( <ASTERISK> | <DIV> | <MOD> ) SyntaxPrimitiveArithmetic() )*
    */
   public Object visit(SyntaxMultiplicativeExpression n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> ( [ <MINUS> ] ( SyntaxCardinalityExpression() | SyntaxAttributeValue() | <LPAREN> SyntaxEquivalenceExpression() <RPAREN> ) | SyntaxValue() )
    */
   public Object visit(SyntaxPrimitiveArithmetic n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <CARDINALITY>
    * f1 -> <LPAREN>
    * f2 -> SyntaxStructureReference()
    * f3 -> <RPAREN>
    */
   public Object visit(SyntaxCardinalityExpression n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> SyntaxPresentExpression()
    *       | SyntaxInstanceOfExpression()
    *       | SyntaxHasInstancesExpression()
    *       | SyntaxHasPartOfTypeExpression()
    *       | SyntaxConnectedExpression()
    *       | SyntaxConnectedToExpression()
    */
   public Object visit(SyntaxConfigurationPredicateExpression n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <PRESENT>
    * f1 -> <LPAREN>
    * f2 -> SyntaxStructureReference()
    * f3 -> <RPAREN>
    */
   public Object visit(SyntaxPresentExpression n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <INSTANCEOF>
    * f1 -> <LPAREN>
    * f2 -> SyntaxStructureReference()
    * f3 -> <COMMA>
    * f4 -> <IDENTIFIER>
    * f5 -> <RPAREN>
    */
   public Object visit(SyntaxInstanceOfExpression n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <HASINSTANCES>
    * f1 -> <LPAREN>
    * f2 -> <IDENTIFIER>
    * f3 -> <RPAREN>
    */
   public Object visit(SyntaxHasInstancesExpression n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <HASPART_OFTYPE>
    * f1 -> <LPAREN>
    * f2 -> [ SyntaxStructureReference() <COMMA> ]
    * f3 -> <IDENTIFIER>
    * f4 -> <RPAREN>
    */
   public Object visit(SyntaxHasPartOfTypeExpression n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <CONNECTED>
    * f1 -> <LPAREN>
    * f2 -> SyntaxStructureReference()
    * f3 -> <RPAREN>
    */
   public Object visit(SyntaxConnectedExpression n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <CONNECTED_TO>
    * f1 -> <LPAREN>
    * f2 -> SyntaxStructureReference()
    * f3 -> <COMMA>
    * f4 -> SyntaxStructureReference()
    * f5 -> <RPAREN>
    */
   public Object visit(SyntaxConnectedToExpression n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <VALUE>
    * f1 -> <LPAREN>
    * f2 -> [ SyntaxStructureReference() <COMMA> ]
    * f3 -> <IDENTIFIER>
    * f4 -> <RPAREN>
    */
   public Object visit(SyntaxAttributeValue n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <IDENTIFIER>
    * f1 -> [ <STRING_LITERAL> ]
    */
   public Object visit(SyntaxDisplayIdentifier n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> [ SyntaxRootSymbol() | SyntaxStructureReferenceItem() ]
    * f1 -> ( <DOT> SyntaxStructureReferenceItem() )*
    * f2 -> [ <ARROW> SyntaxStructureReferenceItem() ]
    */
   public Object visit(SyntaxStructureReference n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> ( <ASTERISK> | <QUESTION_MARK> | <IDENTIFIER> )
    * f1 -> [ <COLON> <IDENTIFIER> ]
    */
   public Object visit(SyntaxStructureReferenceItem n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> ( <FEATURE> | <COMPONENT> )
    * f1 -> <MINUS>
    * f2 -> <ROOT>
    */
   public Object visit(SyntaxRootSymbol n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <EQUALS>
    *       | <NE>
    *       | <LT>
    *       | <LTE>
    *       | <GT>
    *       | <GTE>
    */
   public Object visit(SyntaxComparisonOperator n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> SyntaxConfigurationComposableReference()
    * f1 -> [ <ARROW> <IDENTIFIER> [ <COLON> <IDENTIFIER> ] [ <EQUALS> SyntaxConfigurationComposableReference() <ARROW> <IDENTIFIER> [ <COLON> <IDENTIFIER> ] ] | <ATTR> <IDENTIFIER> [ <EQUALS> <IDENTIFIER> ] ]
    */
   public Object visit(SyntaxConfigurationReference n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> ( <FEATURE> | <COMPONENT> )
    * f1 -> <MINUS>
    * f2 -> <ROOT>
    * f3 -> ( SyntaxConfigurationReferenceItem() )*
    */
   public Object visit(SyntaxConfigurationComposableReference n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <DOT>
    * f1 -> <IDENTIFIER>
    * f2 -> [ <LBRACKET> <INTEGER_LITERAL> <RBRACKET> ]
    * f3 -> [ <COLON> <IDENTIFIER> ]
    */
   public Object visit(SyntaxConfigurationReferenceItem n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      return _ret;
   }

}
