/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * Created on May 13, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package kumbang.core.model.constraint;

/**
 * @author toasikai
 *
 */
public class AttributeExpression extends IndexedExpression {

	private AttributeReference attr;

	public AttributeExpression(AttributeReference reference) {
		attr = reference;
	}
	
	public boolean appears(Variable var) {
		return attr.appears(var);
	}

	public AttributeReference getAttributeReference() {
		return attr;
	}

	public StructureReference getStructureReference() {
		return attr.getReference();
	}

	public String getName() {
		return attr.getName();
	}

	public boolean equals(Object comp) {
		if (!(comp instanceof AttributeExpression))
			return false;
		
		return attr.equals(((AttributeExpression) comp).attr);
	}
	
	public String toString() {
		return "value(" + attr.toString() + ")";  
	}

	@Override
	public String getModelString(boolean implementation) {
		return "value(" + attr.getModelString(implementation) + ")"; 
	}
}
