/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * Created on May 12, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package kumbang.core.model.constraint;

/**
 * @author toasikai
 *
 */
public class CardinalityExpression extends IndexedExpression {
	/**
	 * The references the cardinality of which is of interest.
	 */
	private StructureReference ref;
	
	public CardinalityExpression(StructureReference ref) {
		this.ref = ref;
		ref.setCardinality();
	}

	public boolean appears(Variable var) {
		return ref.getVariable() == var;
	}

	public StructureReference getReference() {
		return ref;
	}

	public boolean equals(Object obj) {
		if (!(obj instanceof CardinalityExpression))
			return false;
		
		if (ref != ((CardinalityExpression) obj).ref)
			return false;
			
		return true;
	}
	
	public String toString() {
		return "cardinality(" + ref.toString() + ")";
	}

	@Override
	public String getModelString(boolean implementation) {
		return "cardinality(" + ref.getModelString(implementation) + ")";
	}
}
