/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * Created on May 31, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package kumbang.core.model.constraint;

import java.io.Serializable;

/**
 * @author toasikai
 *
 */
public class ConnectedExpression extends BooleanExpression implements Serializable {
	private StructureReference from, to;
	
	public ConnectedExpression(StructureReference ref) {
		from = ref;
	}
	
	public ConnectedExpression(StructureReference from, StructureReference to) {
		this.from = from;
		this.to = to;
	}
	
	public StructureReference getFromReference() {
		return from;
	}
	
	public StructureReference getToReference() {
		return to;
	}

	public boolean appears(Variable var) {
		return from.appears(var) || (to != null && to.appears(var));
	}
	
	public String toString() {
		if (to == null)
			return super.toString() + "connected(" + from.toString() + ")";
		
		return super.toString() + "connected_to(" + from.toString() + ", " + to.toString() + ")";
	}

	@Override
	public String getModelString(boolean implementation) {
		if (to == null)
			return super.toString() + "connected(" + from.getModelString(implementation) + ")";
		
		return super.toString() + "connected_to(" + from.getModelString(implementation) + ", " + to.getModelString(implementation) + ")";
	}
}
