/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * Created on May 12, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package kumbang.core.model.constraint;

import java.util.ArrayList;

/**
 * @author toasikai
 *
 */
public class ConstantExpression extends IntegerExpression {
	private boolean isInteger;
	private int intValue;
	private String stringValue;
	
	public ConstantExpression(int value) {
		isInteger = true;
		intValue = value;
	}
	
	public ConstantExpression(String value) {
		isInteger = false;
		stringValue = value;
	}
		
	public int getValue() {
		return intValue;
	}

	public boolean appears(Variable var) {
		return false;
	}

	public void computePrimitives(ArrayList primitives) {}
	
	public String toString() {
		if (isInteger)
			return "" + intValue;
		
		return stringValue;
	}
	
	public boolean isInteger() {
		return isInteger;
	}

	@Override
	public String getModelString(boolean implementation) {
		return toString();
	}
}
