/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * Created on Jan 11, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package kumbang.core.model.constraint;

import java.io.Serializable;

/**
 * @author toasikai
 *
 */
public class EquivalenceExpression extends BooleanExpression implements Serializable {
	private BooleanExpression left, right;

	public EquivalenceExpression(BooleanExpression left, BooleanExpression right) {
		this.left = left;
		this.right = right;
		
		if (left != null)
			left.setParent(this);
		if (right != null)
			right.setParent(this);
	}
	
	public BooleanExpression getLeft() {
		return left;
	}
	
	public BooleanExpression getRight() {
		return right;
	}
	
	public String toString() {
		return super.toString() + left.toString() + " <=> " + right.toString();
	}

	public boolean appears(Variable var) {
		boolean ret = false;
		
		if (left != null)
			ret |= left.appears(var);
		if (right != null)
			ret |= right.appears(var);
			
		return ret;
	}

	@Override
	public String getModelString(boolean implementation) {
		return super.toString() + left.getModelString(implementation) + " <=> " + right.getModelString(implementation);
	}
}
