/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * Created on Jan 4, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package kumbang.core.model.constraint;

import kumbang.core.model.type.ElementaryType;

/**
 * @author toasikai
 *
 */
public class HasInstancesExpression extends BooleanExpression {
	private ElementaryType type; 
	
	public HasInstancesExpression(ElementaryType type) {
		this.type = type;
	}

	public ElementaryType getComparedType() {
		return type;
	}

	public String toString() {
		return super.toString() + "hasInstances(" + type.getName() + ")"; 
	}
	
	public boolean appears(Variable var) {
		return false;
	}

	@Override
	public String getModelString(boolean implementation) {
		return super.toString() + "has_instances(" + type.getName() + ")"; 
	}
}
