/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * Created on Feb 28, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package kumbang.core.model.constraint;

import kumbang.core.model.type.ComposableType;

/**
 * @author toasikai
 *
 */
public class HasPartOfTypeExpression extends BooleanExpression {
	private ComposableType type;
	private boolean transitive;
	private StructureReference ref;
	
	public HasPartOfTypeExpression(ComposableType type, boolean transitive) {
		this.type = type;
		this.transitive = transitive;
	}
	
	public HasPartOfTypeExpression(ComposableType type, StructureReference sr, boolean transitive) {
		this.type = type;
		this.transitive = transitive;
		ref = sr;
	}
	
	public boolean appears(Variable var) {
		return false;
	}

	public ComposableType getType() {
		return type;
	}
	
	public StructureReference getReference() {
		return ref;
	}
	
	public String toString() {
		String ret = super.toString() + "has_part_of_type(";
	
		if (ref != null)
			ret += ref.toString() + ", ";
			
		ret += type.getName() + ")";
		
		return ret;
	}

	@Override
	public String getModelString(boolean implementation) {
		String ret = super.toString() + "has_part_of_type(";
		
		if (ref != null)
			ret += ref.getModelString(implementation) + ", ";
			
		ret += type.getName() + ")";
		return ret;
	}
}
