/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * Created on Jul 6, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package kumbang.core.model.constraint;

import java.io.Serializable;

/**
 * @author toasikai
 *
 */
public class ImplicationExpression extends BooleanExpression implements Serializable {
	private BooleanExpression head, tail;
	
	public ImplicationExpression(BooleanExpression tail) {
		this.tail = tail;
	}
	
	public ImplicationExpression(BooleanExpression tail, BooleanExpression head) {
		this.tail = tail;
		this.head = head;
		
		if (this.tail != null)
			this.tail.setParent(this);
		if (this.head != null)
			this.head.setParent(this);
	}
			
	public BooleanExpression getHead() {
		return head;
	}
	
	public BooleanExpression getTail() {
		return tail;
	}
	
	public String toString() {
		return super.toString() + tail.toString() + " => " + head.toString();	
	}

	public boolean appears(Variable var) {
		boolean ret = false;
		
		if (tail != null)
			ret |= tail.appears(var);
		if (head != null)
			ret |= head.appears(var);
			
		return ret;
	}

	@Override
	public String getModelString(boolean implementation) {
		return super.toString() + tail.getModelString(implementation) + " => " + head.getModelString(implementation);	
	}
}
