/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * Created on May 16, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package kumbang.core.model.constraint;

import java.util.ArrayList;

/**
 * @author toasikai
 *
 */
public abstract class IndexedExpression extends IntegerExpression {
	/**
	 * The integer by which the variable (N1, N2, ...) is identified in the context
	 * of the constraint in which it appears.
	 * 
	 * Index is information related to the WCRL representation of the constraint, and
	 * therefore it is questionable that this information is in the model package.
	 */
	protected int index;
	
	public int getIndex() {
		return index;
	}

	public void computePrimitives(ArrayList primitives) {
		// TODO One could check for duplicate already before constructing the Values.
		if (primitives.contains(this)) {
			index = primitives.indexOf(this);
			return;	
		}
		
		index = primitives.size() + 1;
		primitives.add(this);
	}
}
