/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * Created on Aug 24, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package kumbang.core.model.constraint;

import kumbang.core.model.type.ElementaryType;

/**
 * @author toasikai
 *
 */
public class InstanceOfExpression extends ReferenceExpression {
	private ElementaryType type;
	
	public InstanceOfExpression(StructureReference sr) {
		super(sr);
	}
	
	public InstanceOfExpression(StructureReference sr, ElementaryType ct) {
		super(sr);
		type = ct;
	}	
	
	public ElementaryType getType() {
		return type; 
	}
	
	public String toString() {
		return super.toString() + "instance_of(" + ref.toString() + ", " + type.getName() + ")";
	}

	@Override
	public String getModelString(boolean implementation) {
		return super.toString() + "instance_of(" + ref.getModelString(implementation) + ", " + type.getName() + ")";
	}
}
