/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * Created on May 12, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package kumbang.core.model.constraint;

import java.util.ArrayList;

/**
 * An expression consisting of cardinalities, attribute values, constants and 
 * operators (*, /, mod, +, -, - (prefix)).
 * 
 * @author toasikai
 */
public abstract class IntegerExpression extends Expression {
	/**
	 * True if the expression is negated, false otherwise.
	 */
	private boolean isNegated;
	
	IntegerExpression() {}

	public abstract boolean appears(Variable var);
	public abstract void computePrimitives(ArrayList primitives);
	
	public void setNegated(boolean value) {
		isNegated = value;
	}

	public boolean isBoolean() {
		return false;
	}
}
