/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * Created on Feb 26, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package kumbang.core.model.core;

import kumbang.core.model.exception.RootAlreadyDefinedException;
import kumbang.core.model.exception.TypeAlreadyDefinedException;

import kumbang.core.model.type.ComponentType;
import kumbang.core.model.type.ComposableType;
import kumbang.core.model.type.InterfaceType;

import java.io.Serializable;
import java.util.Iterator;

/**
 * @author toasikai
 *
 */
public interface ComponentedModel extends Serializable {

	public ComponentType getComponentType(String name);
	
	public void addComponentType(ComponentType type) throws TypeAlreadyDefinedException;
	
	public Iterator<ComponentType> getComponentTypes();
	
	public void removeComponentType(String name);
	
	public int getComponentCount();
	
	public ComponentType getComponentRoot();
	
	public void setComponentRoot(ComponentType type) throws RootAlreadyDefinedException;
	
	// if there are components, there are interfaces as well
	
	public InterfaceType getInterfaceType(String name);
	
	public void addInterfaceType(InterfaceType type) throws TypeAlreadyDefinedException;
	
	public Iterator<InterfaceType> getInterfaceTypes();
	
	public void removeInterfaceType(String name);
	
	public int getInterfaceCount();

	public void removeComponentRoot();

	public void updateTypeName(ComponentType type, String newName);

	public void updateTypeName(InterfaceType type, String newName);
	
	
}
