/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * Created on Feb 26, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package kumbang.core.model.core;

import kumbang.core.model.exception.RootAlreadyDefinedException;
import kumbang.core.model.exception.TypeAlreadyDefinedException;

import kumbang.core.model.type.ComposableType;
import kumbang.core.model.type.FeatureType;

import java.util.Iterator;

import java.io.Serializable;

/**
 * @author toasikai
 *
 */
public interface FeaturedModel extends Serializable {
	
	public FeatureType getFeatureType(String name);
	
	public void addFeatureType(FeatureType type) throws TypeAlreadyDefinedException;
	
	public Iterator<FeatureType> getFeatureTypes();
	
	public void removeFeatureType(String name);
	
	public int getFeatureCount();
	
	public FeatureType getFeatureRoot();
	
	public void setFeatureRoot(FeatureType type) throws RootAlreadyDefinedException;

	public void removeFeatureRoot();

	public void updateTypeName(FeatureType type, String newName);


}
