/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * 
 */
package kumbang.core.model.core;

import kumbang.core.model.type.ElementaryType;

import java.io.Serializable;

import java.util.Iterator;

/**
 * @author toasikai
 * @author vmyllarn
 *
 */
public abstract class Model implements Serializable  {
	
	private String name;

	public Model(String name) {
		this.name = name;

	}

	public String getName() {
		return name;
	}
	
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * Returns an upper-case string representation of this
	 * model and its kind, e.g. "Forfamel", "Koalish", "Kumbang".
	 * @return String
	 */
	abstract public String getModelKind();
	
	
	/**
	 * Returns a type with the given name and given type kind.
	 * Returns null if no such type exists, or the model does not
	 * support this particular type kind.
	 * @param name
	 * @param typeKind
	 * @return ElementaryType
	 */
	abstract public ElementaryType getType(String name, String typeKind);
	
}
