/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * Created on Feb 17, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package kumbang.core.model.exception;

import java.util.ArrayList;
import java.util.List;
import java.util.Iterator;

import kumbang.core.model.type.ComposableType;

/**
 * @author toasikai
 *
 */
public class OnesOwnPartException extends Exception {
	
	private List chain = new ArrayList();
	private ComposableType whole, part;
	
	public OnesOwnPartException(ComposableType whole, ComposableType part) {
		super("Type " + whole + " cannot be a part of its own through part "  + part + ".");
		this.whole = whole;
		this.part = part;
	}
	
	public void addType(ComposableType between) {
		chain.add(between);
	}
	
	public boolean isDirect() {
		return chain.isEmpty() && whole == part;
	}
	
	public boolean isDirectSuper() {
		return chain.isEmpty();
	}
	
	public Iterator types() {
		return chain.iterator();
	}
	
	public ComposableType getPartType() {
		return part;
	}
	
	public ComposableType getWholeType() {
		return whole;
	}
}
