/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * Created on Feb 17, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package kumbang.core.model.exception;

import java.util.ArrayList;
import java.util.List;

import kumbang.core.model.type.ComposableType;

/**
 * @author toasikai
 *
 */
public class OnesOwnSupertypeException extends Exception {
	
	private ComposableType type;
	private List<ComposableType> types; 
	
	public OnesOwnSupertypeException(ComposableType type)  {
		this.type = type;
		types = new ArrayList<ComposableType>();
	}
	
	public void addType(ComposableType ft) {
		types.add(ft);
	}
	
	public String getMessage() {
		String msg = type.getTypeKind() + " type " 
		+ type.getName() + " declares a supertype of itself through inheriting ";
		if (types.isEmpty()) {
			msg += "itself.";
		} else {
			for (ComposableType superType : types) {
				msg += superType.getName() + " -> ";
			}
			msg += type.getName() + ".";
		}
		return msg;
	}
}
