/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * Created on Feb 27, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package kumbang.core.model.type;

import kumbang.core.model.constraint.OldInterfaceReference;

import java.io.Serializable;

/**
 * @author toasikai
 *
 */
public class Connection implements Serializable {
	private OldInterfaceReference source;
	private OldInterfaceReference target; 
	
	public Connection(OldInterfaceReference source, OldInterfaceReference target) {
		this.source = source;
		this.target = target;
	}
	
	public PartDefinition getSourcePart() {
		return source.getPart();
	}
	
	public PartDefinition getTargetPart() {
		return target.getPart();
	}
	
	public InterfaceDefinition getSourceInterface() {
		return source.getInterface(); 
	}
	
	public InterfaceDefinition getTargetInterface() {
		return target.getInterface(); 
	}
	
	public String toString() {
		String ret = new String();
		
		if (source.getPart() != null)
			ret += getSourcePart().getName() + ".";
			
		ret += getSourceInterface().getName() + " = ";
		
		if (getTargetPart() != null)
			ret += getTargetPart().getName() + ".";
			
		ret += getTargetInterface().getName();
		
		return ret; 
	}
	
	public OldInterfaceReference getSource() {
		return source;
	}
	
	public OldInterfaceReference getTarget() {
		return target;
	}
	
}
