/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * ElementaryDefinition.java
 *
 * Created on 29. huhtikuuta 2004, 14:49
 */

package kumbang.core.model.type;

import java.io.Serializable;

/**
 *
 * @author  vmyllarn
 */
public abstract class ElementaryDefinition implements Serializable {

	private Name name;

	/** Creates a new instance of ElementaryDefinition */
	public ElementaryDefinition(Name name) {
		this.name = name;
	}

	/** Creates a new instance of ElementaryDefinition */
	public ElementaryDefinition(String name) {
		this.name = new Name(name);
	}
    
    public boolean hasDisplayName() {
        return name.hasDisplayName();
    }
    
	public String getName() {
		return name.getName();
	}
	

	public void setName(String name) {
		this.name.setName(name);
	}
	
	public void setDisplayName(String name){
		this.name.setDisplayName(name);
	}
	
	
	public String getDisplayName() {
		return name.getDisplayName();
	}
    
//    public boolean equals(Object o) {
//        return o instanceof ElementaryDefinition
//                && ((ElementaryDefinition) o).getName().equals(name);
//    }
    
	/**
	 * TODO Check when it is more appropriate to use the display name.
	 * 
	 */
	public String toString() {
		return this.name.toString();
	}

}
