/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * ElementaryType.java
 *
 * Created on 16. maaliskuuta 2004, 15:28
 */

package kumbang.core.model.type;

import java.io.Serializable;

/**
 * Why couldn't this class have the name Type? What is so elementary about it? -toasikai
 *
 * @author  vmyllarn
 */
public abstract class ElementaryType implements Serializable {
    
    private Name name;
    
    public ElementaryType(Name name) {
        this.name = name;
    }
    
    public ElementaryType(String name) {
        this.name = new Name(name);
    }
    
    public boolean hasDisplayName() {
        return name.hasDisplayName();
    }
    
    public String getName() {
        return name.getName();
    }
    
	public String getDisplayName() {
		return name.getDisplayName();
	}
    
    public void setName(String name) {
        this.name.setName(name);
    }
    
    public String toString() {
        return this.name.toString();
    }
    
	public void setDisplayName(String name){
		this.name.setDisplayName(name);
	}
    
//    public boolean equals(Object o) {
//        return o instanceof ElementaryType
//                && ((ElementaryType) o).getName().equals(name);
//    }
    
    /**
     * Returns a lower-case string that represents name of the entities
     * of the type. For example "component", "feature", "interface" etc.
     * @return String a lower-case entity name
     */
    abstract public String getTypeKind();
}
