/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * Colors.java
 *
 * Created on 15. huhtikuuta 2004, 20:05
 */

package kumbang.util.gui;

import java.awt.Color;

/**
 *
 * @author  vmyllarn
 */
public class Colors {
    
    public static final Color COMPONENT = new Color(205, 220, 235);
    public static final Color FEATURE = new Color(205, 235, 220);
    public static final Color INTERFACE = new Color(250, 250, 210);
    public static final Color POTENTIAL_BACKGROUND = Color.LIGHT_GRAY;
    public static final Color POTENTIAL_FOREGROUND = Color.GRAY;
    public static final Color EMPTY = Color.WHITE;
    
    //public static final Color BACKGROUND = new Color(230, 236, 242);
    public static final Color FOREGROUND = Color.BLACK;
    public static final Color COMPONENT_BACKGROUND = new Color(225, 230, 235);
    public static final Color FEATURE_BACKGROUND = new Color(225, 235, 230);
    
    public static final Color SELECTION = new Color(230, 130, 20);
    public static final Color SELECTION_TREE = new Color(220, 150, 70);
    //public static final Color ACTION = new Color(250, 220, 180);
    public static final Color ACTION = new Color(250, 179, 83);
    
    public static final Color EXCLUDED = Color.GRAY;
    
    public static final Color DARK_THUNDER = new Color(96, 120, 140);
    public static final Color THUNDER = new Color(140, 152, 164);
    public static final Color LIGHT_THUNDER = new Color(164, 176, 188);
    
    public static final Color DARK_BEIGE = new Color(128, 128, 124);
    public static final Color BEIGE = new Color(160, 160, 155);
    public static final Color LIGHT_BEIGE = new Color(240, 240, 235);
    
    
    /** Private constructor, this is a library class */
    private Colors() {
    }
    
}
