/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * Icons.java
 *
 * Created on 19. huhtikuuta 2004, 15:47
 */

package kumbang.util.gui;

import javax.swing.ImageIcon;

/**
 *
 * @author  vmyllarn
 */
public class Icons {
    
    /** Creates a new instance of Icons */
    private Icons() {
    }
    
    public static int ICON_SIZE = 16;
    public static int ICON_SIZE_LARGE = 24;
    
    
    public static final ImageIcon COMPONENT = new ImageIcon(Icons.class.getClassLoader().getResource("pics/component.gif"));
    public static final ImageIcon FEATURE = new ImageIcon(Icons.class.getClassLoader().getResource("pics/feature.gif"));
    public static final ImageIcon FEATURE_OPTIONAL = new ImageIcon("pics/featureOptional.gif");
    public static final ImageIcon FEATURE_MANDATORY = new ImageIcon(Icons.class.getClassLoader().getResource("pics/featureMandatory.gif"));
    public static final ImageIcon INTERFACE = new ImageIcon(Icons.class.getClassLoader().getResource("pics/interface_req.gif"));
    public static final ImageIcon ATTRIBUTE = new ImageIcon(Icons.class.getClassLoader().getResource("pics/attribute.gif"));
    public static final ImageIcon PART = new ImageIcon(Icons.class.getClassLoader().getResource("pics/part.gif"));
    public static final ImageIcon SUBFEATURE_ROLE = new ImageIcon(Icons.class.getClassLoader().getResource("pics/subfeatureRole.gif"));
    public static final ImageIcon BINDING_SOURCE = new ImageIcon(Icons.class.getClassLoader().getResource("pics/binding_source.gif"));
    public static final ImageIcon BINDING_TARGET = new ImageIcon(Icons.class.getClassLoader().getResource("pics/binding_target.gif"));
    
    public static final ImageIcon DIAGRAM = new ImageIcon(Icons.class.getClassLoader().getResource("pics/diagram.gif"));
    public static final ImageIcon STRUCTURE = new ImageIcon(Icons.class.getClassLoader().getResource("pics/structure.gif"));
    public static final ImageIcon TYPE = new ImageIcon(Icons.class.getClassLoader().getResource("pics/type.gif"));
    
    public static final ImageIcon UP = new ImageIcon(Icons.class.getClassLoader().getResource("pics/up.gif"));
    public static final ImageIcon DOWN = new ImageIcon(Icons.class.getClassLoader().getResource("pics/down.gif"));
    public static final ImageIcon RIGHT = new ImageIcon(Icons.class.getClassLoader().getResource("pics/right.gif"));
    public static final ImageIcon LEFT = new ImageIcon(Icons.class.getClassLoader().getResource("pics/left.gif"));
    
    public static final ImageIcon SELECT = new ImageIcon(Icons.class.getClassLoader().getResource("pics/select.gif"));
    public static final ImageIcon MOVE = new ImageIcon(Icons.class.getClassLoader().getResource("pics/move.gif"));
    public static final ImageIcon CONNECT = new ImageIcon(Icons.class.getClassLoader().getResource("pics/connect.gif"));
    public static final ImageIcon DISCONNECT = new ImageIcon(Icons.class.getClassLoader().getResource("pics/disconnect.gif"));
    
    public static final ImageIcon NEW = new ImageIcon(Icons.class.getClassLoader().getResource("pics/new.gif"));
    public static final ImageIcon NEW_COMPONENT = new ImageIcon(Icons.class.getClassLoader().getResource("pics/newComponent.gif"));
    public static final ImageIcon NEW_INTERFACE = new ImageIcon(Icons.class.getClassLoader().getResource("pics/newInterface.gif"));
    public static final ImageIcon NEW_FEATURE = new ImageIcon(Icons.class.getClassLoader().getResource("pics/newFeature.gif"));
    public static final ImageIcon NEW_ATTRIBUTE = new ImageIcon(Icons.class.getClassLoader().getResource("pics/newAttribute.gif"));
    
    public static final ImageIcon EDIT = new ImageIcon(Icons.class.getClassLoader().getResource("pics/edit.gif"));
    public static final ImageIcon DELETE = new ImageIcon(Icons.class.getClassLoader().getResource("pics/delete.gif"));
    public static final ImageIcon ADD = new ImageIcon(Icons.class.getClassLoader().getResource("pics/add.gif"));
    public static final ImageIcon ZOOM = new ImageIcon(Icons.class.getClassLoader().getResource("pics/zoom.gif"));
    
    public static final ImageIcon SAVE = new ImageIcon(Icons.class.getClassLoader().getResource("pics/save.gif"));
    public static final ImageIcon OPEN = new ImageIcon(Icons.class.getClassLoader().getResource("pics/open.gif"));
    public static final ImageIcon CLOSE = new ImageIcon(Icons.class.getClassLoader().getResource("pics/close.gif"));
    public static final ImageIcon IMPORT = new ImageIcon(Icons.class.getClassLoader().getResource("pics/import.gif"));
    public static final ImageIcon EXPORT = new ImageIcon(Icons.class.getClassLoader().getResource("pics/export.gif"));
    
    public static final ImageIcon INFO = new ImageIcon(Icons.class.getClassLoader().getResource("pics/info.gif"));
    public static final ImageIcon COMPUTE = new ImageIcon(Icons.class.getClassLoader().getResource("pics/computeServer.gif"));
    public static final ImageIcon REFRESH = new ImageIcon(Icons.class.getClassLoader().getResource("pics/refresh.gif"));
    
    
    public static final ImageIcon STATUS_INVALID = new ImageIcon(Icons.class.getClassLoader().getResource("pics/statusInvalid.gif"));
    
    /** large icons start here (size = 24) */
    
    public static final ImageIcon COMPONENT_L = new ImageIcon(Icons.class.getClassLoader().getResource("pics/component_large.gif"));
    public static final ImageIcon FEATURE_L = new ImageIcon(Icons.class.getClassLoader().getResource("pics/feature_large.gif"));
    public static final ImageIcon FEATURE_OPTIONAL_L = new ImageIcon(Icons.class.getClassLoader().getResource("pics/featureOptional_large.gif"));
    public static final ImageIcon FEATURE_MANDATORY_L = new ImageIcon(Icons.class.getClassLoader().getResource("pics/featureMandatory_large.gif"));
    public static final ImageIcon INTERFACE_L = new ImageIcon(Icons.class.getClassLoader().getResource("pics/interface_large.gif"));
    public static final ImageIcon ATTRIBUTE_L = new ImageIcon(Icons.class.getClassLoader().getResource("pics/attribute_large.gif"));
    public static final ImageIcon PART_L = new ImageIcon(Icons.class.getClassLoader().getResource("pics/part_large.gif"));
    public static final ImageIcon SUBFEATURE_ROLE_L = new ImageIcon(Icons.class.getClassLoader().getResource("pics/subfeatureRole_large.gif"));
    public static final ImageIcon BINDING_SOURCE_L = new ImageIcon(Icons.class.getClassLoader().getResource("pics/binding_source_large.gif"));
    public static final ImageIcon BINDING_TARGET_L = new ImageIcon(Icons.class.getClassLoader().getResource("pics/binding_target_large.gif"));
    
    //public static final ImageIcon DIAGRAM_L = new ImageIcon("pics/diagram.gif");
    public static final ImageIcon STRUCTURE_L = new ImageIcon(Icons.class.getClassLoader().getResource("pics/structure_large.gif"));
    public static final ImageIcon TYPE_L = new ImageIcon(Icons.class.getClassLoader().getResource("pics/type_large.gif"));
    
    public static final ImageIcon INFO_L = new ImageIcon(Icons.class.getClassLoader().getResource("pics/info_large.gif"));
    public static final ImageIcon STATUS_COMPLETE_L = new ImageIcon(Icons.class.getClassLoader().getResource("pics/statusComplete_large.gif"));
    public static final ImageIcon STATUS_INCOMPLETE_L = new ImageIcon(Icons.class.getClassLoader().getResource("pics/statusIncomplete_large.gif"));
    public static final ImageIcon STATUS_INVALID_L = new ImageIcon(Icons.class.getClassLoader().getResource("pics/statusInvalid_large.gif"));
    
    public static final ImageIcon UP_L = new ImageIcon(Icons.class.getClassLoader().getResource("pics/up_large.gif"));
    public static final ImageIcon DOWN_L = new ImageIcon(Icons.class.getClassLoader().getResource("pics/down_large.gif"));
    public static final ImageIcon RIGHT_L = new ImageIcon(Icons.class.getClassLoader().getResource("pics/right_large.gif"));
    public static final ImageIcon LEFT_L = new ImageIcon(Icons.class.getClassLoader().getResource("pics/left_large.gif"));
}
