/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * KumbangMetalTheme.java
 *
 * Created on 15. huhtikuuta 2004, 18:49
 */

package kumbang.util.gui;

import javax.swing.plaf.ColorUIResource;
import javax.swing.plaf.FontUIResource;

import javax.swing.plaf.metal.DefaultMetalTheme;

/**
 *
 * @author  vmyllarn
 */
public class KumbangMetalTheme extends DefaultMetalTheme {
    
    private final ColorUIResource primary1 
            = new ColorUIResource(Colors.DARK_THUNDER);
    private final ColorUIResource primary2 
            = new ColorUIResource(Colors.THUNDER);
    private final ColorUIResource primary3 
            = new ColorUIResource(Colors.LIGHT_THUNDER);
    
    private final ColorUIResource secondary1 
            = new ColorUIResource(Colors.DARK_BEIGE);
    private final ColorUIResource secondary2 
            = new ColorUIResource(Colors.BEIGE);
    private final ColorUIResource secondary3 
            = new ColorUIResource(Colors.LIGHT_BEIGE);
    
    private final ColorUIResource focus 
            = new ColorUIResource(Colors.ACTION);
    
    
    /** Creates a new instance of KumbangMetalTheme */
    public KumbangMetalTheme() {
    }
    
    public String getName() { 
        return "Kumbang";
    }
    
    
    protected ColorUIResource getPrimary1() { 
        return primary1;
    }
    
    protected ColorUIResource getPrimary2() { 
        return primary2; 
    } 
    
    protected ColorUIResource getPrimary3() { 
        return primary3; 
    } 
    
    protected ColorUIResource getSecondary1() { 
        return secondary1; 
    }
    
    protected ColorUIResource getSecondary2() { 
        return secondary2; 
    }
    
    protected ColorUIResource getSecondary3() { 
        return secondary3; 
    }
 
    public FontUIResource getControlTextFont() {
        return getUserTextFont();
    }
    
    public FontUIResource getMenuTextFont() {
        return getUserTextFont();
    }
    
    public ColorUIResource getDesktopColor() { 
        return primary1;
    }
    
    public ColorUIResource getFocusColor() {
        return focus;
    }
}
