/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 * Margins.java
 *
 * Created on 19. huhtikuuta 2004, 16:08
 */

package kumbang.util.gui;

import java.awt.Component;
import java.awt.Dimension;

import javax.swing.BorderFactory;
import javax.swing.Box;

import javax.swing.border.Border;

/**
 *
 * @author  vmyllarn
 */
public class Margins {
    
    public static final int XS = 2;
    public static final int S = 5;
    public static final int M = 10;
    public static final int L = 20;
    public static final int XL = 40;
    
    public static final Dimension DIMENSION_HEIGHT_XL = new Dimension(0, 40);
    public static final Dimension DIMENSION_HEIGHT_L = new Dimension(0, 20);
    public static final Dimension DIMENSION_HEIGHT_M = new Dimension(0, 10);
    public static final Dimension DIMENSION_HEIGHT_S = new Dimension(0, 5);
    public static final Dimension DIMENSION_HEIGHT_XS = new Dimension(0, 2);
    
    public static final Dimension DIMENSION_WIDTH_XL = new Dimension(40, 0);
    public static final Dimension DIMENSION_WIDTH_L = new Dimension(20, 0);
    public static final Dimension DIMENSION_WIDTH_M = new Dimension(10, 0);
    public static final Dimension DIMENSION_WIDTH_S = new Dimension(5, 0);
    public static final Dimension DIMENSION_WIDTH_XS = new Dimension(2, 0);
    
    public static final Dimension LIST_SIZE = new Dimension(150,150);
    
    
    public static Component createHorizontalMarginXS() {
        return Box.createRigidArea(DIMENSION_WIDTH_XS);
    }
    
    public static Component createHorizontalMarginS() {
        return Box.createRigidArea(DIMENSION_WIDTH_S);
    }
    
    public static Component createHorizontalMarginM() {
        return Box.createRigidArea(DIMENSION_WIDTH_M);
    }
    
    public static Component createHorizontalMarginL() {
        return Box.createRigidArea(DIMENSION_WIDTH_L);
    }
    
    public static Component createHorizontalMarginXL() {
        return Box.createRigidArea(DIMENSION_WIDTH_XL);
    }
    
    public static Component createVerticalMarginXS() {
        return Box.createRigidArea(DIMENSION_HEIGHT_XS);
    }
    
    public static Component createVerticalMarginS() {
        return Box.createRigidArea(DIMENSION_HEIGHT_S);
    }
    
    public static Component createVerticalMarginM() {
        return Box.createRigidArea(DIMENSION_HEIGHT_M);
    }
    
    public static Component createVerticalMarginL() {
        return Box.createRigidArea(DIMENSION_HEIGHT_L);
    }
    
    public static Component createVerticalMarginXL() {
        return Box.createRigidArea(DIMENSION_HEIGHT_XL);
    }
    
    public static Border createEmptyBorderXS() {
        return BorderFactory.createEmptyBorder(XS, XS, XS, XS);
    }
    
    public static Border createEmptyBorderS() {
        return BorderFactory.createEmptyBorder(S, S, S, S);
    }
    
    public static Border createEmptyBorderM() {
        return BorderFactory.createEmptyBorder(M, M, M, M);
    }
    
    public static Border createEmptyBorderL() {
        return BorderFactory.createEmptyBorder(L, L, L, L);
    }
    
    public static Border createEmptyBorderXL() {
        return BorderFactory.createEmptyBorder(XL, XL, XL, XL);
    }
    
    /** Creates a new instance of Margins */
    private Margins() {
    }
    
    
}
